package scenes 
{
	import jp.progression.casts.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.commands.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.loader.*;
	import jp.progression.*;
	import jp.progression.scenes.*;
	import pages.AmericanPhoto;
	import pages.AmericanText;
	
	/**
	 * ...
	 * @author aoki
	 */
	public class AmericanScene extends SceneObject 
	{
		private var americanPhoto:AmericanPhoto;
		private var americanText:AmericanText;
		/**
		 * 新しい AmericanScene インスタンスを作成します。
		 */
		public function AmericanScene( name:String = null, initObject:Object = null ) 
		{
			// 親クラスを初期化する
			super( name, initObject );
			
			// シーンタイトルを設定します。
			title = "title";
			
			americanPhoto = new AmericanPhoto();
			americanPhoto.x = 120;
			americanPhoto.y = 40;
			americanText = new AmericanText();
			americanText.x = 119;
			americanText.y = 354;
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは子階層だった場合に、階層が変更された直後に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneLoad():void {
			GalleryScene(parent).backButton.sceneId = new SceneId( "/index/gallery/mame" );
			GalleryScene(parent).nextButton.sceneId = new SceneId( "/index/gallery/french" );
			addCommand(
				new AddChild( container , GalleryScene(parent).photoBG ),
				new AddChild( container , GalleryScene(parent).closeButton ),
				new AddChild( container , GalleryScene(parent).photoBase ),
				new AddChild( container , GalleryScene(parent).backButton ),
				new AddChild( container , GalleryScene(parent).nextButton ),
				new AddChild( container , americanPhoto ),
				new AddChild( container , americanText )
			);
		}
		
		/**
		 * シーンオブジェクト自身が目的地だった場合に、到達した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneInit():void 
		{
		}
		
		/**
		 * シーンオブジェクト自身が出発地だった場合に、移動を開始した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneGoto():void 
		{
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは親階層だった場合に、階層が変更される直前に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneUnload():void {
			addCommand(
				new RemoveChild( container , americanPhoto ),
				new RemoveChild( container , americanText )
			);
		}
	}
}
