package scenes 
{
	import jp.progression.casts.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.commands.*;
	import jp.progression.core.impls.IDisposable;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.loader.*;
	import jp.progression.*;
	import jp.progression.scenes.*;
	import pages.GalleryPage;
	import pages.PhotoBase;
	import pages.PhotoBG;
	import ui.NextButton;
	import ui.*;
	
	/**
	 * ...
	 * @author aoki
	 */
	public class GalleryScene extends SceneObject 
	{
		private var americanScene:AmericanScene;
		private var frenchScene:FrenchScene;
		private var mameScene:MameScene;
		private var galleryPage:GalleryPage;
		private var americanButton:AmericanButton;
		private var frenchButton:FrenchButton;
		private var mameButton:MameButton;
		public var photoBG:PhotoBG;
		public var photoBase:PhotoBase;
		public var closeButton:CloseButton;
		public var backButton:BackButton;
		public var nextButton:NextButton;
		
		/**
		 * 新しい GalleryScene インスタンスを作成します。
		 */
		public function GalleryScene( name:String = null, initObject:Object = null ) 
		{
			// 親クラスを初期化する
			super( name, initObject );
			
			// シーンタイトルを設定します。
			title = "title";
			
			americanScene = new AmericanScene();
			americanScene.name = "american";
			addScene( americanScene );
			frenchScene = new FrenchScene();
			frenchScene.name = "french";
			addScene( frenchScene );
			mameScene = new MameScene();
			mameScene.name = "mame";
			addScene( mameScene );
			
			galleryPage = new GalleryPage();
			galleryPage.x = 151;
			galleryPage.y = 113;
			americanButton = new AmericanButton();
			americanButton.x = 150;
			americanButton.y = 161;
			frenchButton = new FrenchButton();
			frenchButton.x = 270;
			frenchButton.y = 161;
			mameButton = new MameButton();
			mameButton.x = 390;
			mameButton.y = 161;
			
			photoBG = new PhotoBG();
			photoBase = new PhotoBase();
			photoBase.x = 100;
			photoBase.y = 20;
			closeButton = new CloseButton();
			closeButton.x = 507;
			closeButton.y = 30;
			backButton = new BackButton();
			backButton.x = 30;
			backButton.y = 220;
			nextButton = new NextButton();
			nextButton.x = 570;
			nextButton.y = 220;
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは子階層だった場合に、階層が変更された直後に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneLoad():void {
			addCommand(
				new AddChild( container , galleryPage ),
				new AddChild( container , americanButton ),
				new AddChild( container , frenchButton ),
				new AddChild( container , mameButton )
			);
		}
		override protected function atSceneInit():void {
			addCommand(
				new RemoveChild( container , photoBG ),
				new RemoveChild( container , photoBase ),
				new RemoveChild( container , closeButton ),
				new RemoveChild( container , backButton ),
				new RemoveChild( container , nextButton )
			);
		}
		override protected function atSceneUnload():void {
			addCommand(
				new RemoveChild( container , galleryPage ),
				new RemoveChild( container , americanButton ),
				new RemoveChild( container , frenchButton ),
				new RemoveChild( container , mameButton )
			);
		}
	}
}
