package ui 
{
	import flash.display.Bitmap;
	import jp.progression.casts.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.commands.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.scenes.*;
	import pages.Effect;
	
	/**
	 * ...
	 * @author aoki
	 */
	public class GalleryButton extends CastButton 
	{
		[Embed(source = "../images/galleryButton.png")]
		private var Emb:Class;
		private var effect:Effect;
		/**
		 * 新しい GalleryButton インスタンスを作成します。
		 */
		public function GalleryButton( initObject:Object = null ) 
		{
			// 親クラスを初期化します。
			super( initObject );
			
			var img:Bitmap = new Emb() as Bitmap;
			addChild( img );
			
			// 移動先となるシーン識別子を設定します。
			sceneId = new SceneId( "/index/gallery" );
			
			effect = new Effect();
			effect.x = -70;
			effect.alpha = 0;
		}
		
		/**
		 * IExecutable オブジェクトが AddChild コマンド、または AddChildAt コマンド経由で表示リストに追加された場合に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastAdded():void 
		{
		}
		
		/**
		 * IExecutable オブジェクトが RemoveChild コマンド、または RemoveAllChild コマンド経由で表示リストから削除された場合に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastRemoved():void 
		{
		}
		
		/**
		 * Flash Player ウィンドウの CastButton インスタンスの上でユーザーがポインティングデバイスのボタンを押すと送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastMouseDown():void 
		{
		}
		
		/**
		 * ユーザーが CastButton インスタンスからポインティングデバイスを離したときに送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastMouseUp():void 
		{
		}
		
		/**
		 * ユーザーが CastButton インスタンスにポインティングデバイスを合わせたときに送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastRollOver():void 
		{
			addCommand(
				new AddChild( this , effect ),
				new DoTweener( effect , { alpha:1 , x:0 , time:.2 , transition:"easeOutCirc" } )
			);
		}
		
		/**
		 * ユーザーが CastButton インスタンスからポインティングデバイスを離したときに送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atCastRollOut():void 
		{
			addCommand(
				new DoTweener( effect , { alpha:0 , x: -70 , time:.2 , transition:"easeInCirc" } ),
				new RemoveChild( this , effect )
			);
		}
	}
}
